package lel.flummi.skilloverlay.api;

import java.io.InputStreamReader;
import java.net.URL;
import java.util.HashMap;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;

import lel.flummi.skilloverlay.api.records.Skills;
import lel.flummi.skilloverlay.api.records.Skills.Skill;
import lel.flummi.skilloverlay.config.skilloverlayconfig;

public class PlayerSkills {
	public static HashMap<String, Skill> SKILLS;

	public static void init() {
		String apikey = skilloverlayconfig.get().general.apiKey;
		String apiurl = "https://api.hypixel.net/resources/skyblock/skills?key=" + apikey;

		if (apikey.length() > 0) {
			Skills skills = PlayerSkills.updateSkills(apiurl);
			if (skills != null) {
				SKILLS = skills.skills();
			} else {
				System.out.println("leer uff");
			}
		}
	}

	public static Skills updateSkills(String apiurl) {
		if (apiurl.length() == 0)
			return null;

		try {
			URL url = new URL(apiurl);
			InputStreamReader reader = new InputStreamReader(url.openStream());
			Gson gson = new GsonBuilder()
					.serializeNulls()
					.create();
			return gson.fromJson(reader, Skills.class);
		} catch (Exception e) {
			e.printStackTrace();
		}
		return null;
	}
}
